package uoc.ei.pfc;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;


public class HttpClient {

	//Monta la peticio HTTP amb els parametres que es vulguin enviar
	public static String sendParameters(String schema, String host, int port, String path, List<String[]> parameters) throws IOException {
		InputStream content = null;
		String result = null;
		StringBuilder URLParameters = new StringBuilder();
		try {
			URLParameters.append(path);
			for(String[] parameter : parameters){//Afegeix els aprametres a la URL
				URLParameters.append(parameter[0]);
				URLParameters.append("=");
				URLParameters.append(parameter[1]);
				URLParameters.append("&");
			}
			URLParameters.deleteCharAt(URLParameters.length()-1);	//Elimina l'ultim & sobrant
			URL url = new URL(schema, host, port, URLParameters.toString());
			HttpParams httpParams = new BasicHttpParams();
			HttpConnectionParams.setConnectionTimeout(httpParams, 3000);	//3 segons de timeout		
			DefaultHttpClient httpclient = new DefaultHttpClient(httpParams);

			HttpResponse response = httpclient.execute(new HttpGet(url.toURI()));	//Envia la peticio
			content = response.getEntity().getContent();
			result = convertStreamToString(content);	//Converteix el resultat en una cadena de text
		} catch (Exception e) {
			result = null;
		} finally {
			if (content != null) {
				content.close();
			}
		}
		return result;
	}	
	
	//Converteix el resultat de la peticio en una cadena text per tal de poder-la llegir
	private static String convertStreamToString(InputStream is) {
	    BufferedReader reader = new BufferedReader(new InputStreamReader(is));
	    StringBuilder sb = new StringBuilder();

	    String line = null;
	    try {
	        while ((line = reader.readLine()) != null) {
	            sb.append(line + "\n");
	        }
	    } catch (IOException e) {
	        e.printStackTrace();
	    } finally {
	        try {
	            is.close();
	        } catch (IOException e) {
	            e.printStackTrace();
	        }
	    }
	    return sb.toString();
	}
	
}
