package uoc.ei.pfc;

import uoc.ei.pfc.alarm.AlarmScheduler;
import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends Activity {
	
	private TextView server;
	private TextView wiflyConnection;
	private TextView wiflyStatus;
	private Context context;
	private RegisterGCM registerGCM;
	private Button checkServer;
	private Button stopAlarm;
	private AlarmScheduler alarmScheduler;
	


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		//Obtencio de les variables de la interficie grafica i injeccio de dependencies.
		setContentView(R.layout.debug);	
		server = (TextView)findViewById(R.id.serverConnValue);
		wiflyConnection = (TextView)findViewById(R.id.wiflyConnValue);
		wiflyStatus = (TextView)findViewById(R.id.wiflyStatusValue);
		checkServer = (Button)findViewById(R.id.btnCheckServer);
		stopAlarm = (Button)findViewById(R.id.btnStopAlarm);
		context = getApplicationContext();
		registerGCM = new RegisterGCM(context);
		registerGCM.register();	
		alarmScheduler = new AlarmScheduler(this);
		SendAsyncAction.serverConnection = server;
		SendAsyncAction.wiflyConnection = wiflyConnection;
		SendAsyncAction.wiflyStatus = wiflyStatus;
		SendAsyncAction.sendAction(ParametersBuilder.testServer());
	
		//Accio del boto de consulta activa de l'estat del servidor i alarma
		checkServer.setOnClickListener(new View.OnClickListener() {
			   @Override
			   public void onClick(View v) {
				   SendAsyncAction.sendAction(ParametersBuilder.testServer());
			   }
			  });
		
		//Accio del boto per parar l'alarma saltada.
		stopAlarm.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				SendAsyncAction.sendAction(ParametersBuilder.stopAlarm());				
			}
		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		//Menu, en aquest cas no hi haura res
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		//Manegador del menu. En aquesta aplicacio esta buit.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
	

}
