package uoc.ei.pfc;

import uoc.ei.pfc.alarm.AlarmScheduler;
import android.app.IntentService;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.NotificationCompat;
import android.util.Log;

import com.google.android.gms.gcm.GoogleCloudMessaging;

public class NotificationHandler extends IntentService {
    public static final int NOTIFICATION_ID = 1;
    private NotificationManager mNotificationManager;
    NotificationCompat.Builder builder;     
    
    public NotificationHandler() {
        super("GcmIntentService");
      
    }

    @Override
    protected void onHandleIntent(Intent intent) {
        Bundle extras = intent.getExtras();
        GoogleCloudMessaging gcm = GoogleCloudMessaging.getInstance(this);
      
        // Intent rebut al BroadcastReceiver.
        String messageType = gcm.getMessageType(intent);

        if (!extras.isEmpty()) { 
            /*
             * Filtre del tipus de missatge es recomanat per la API. La finalitat es evitar que en el futur 
             * nous tipus missatges puguin produir errors.
             */
            if (GoogleCloudMessaging.MESSAGE_TYPE_SEND_ERROR.equals(messageType)) {
                sendNotification("Send error: " + extras.toString());
            } else if (GoogleCloudMessaging.MESSAGE_TYPE_DELETED.equals(messageType)) {
                sendNotification("Deleted messages on server: " +  extras.toString());
            // Aquest es el tipus normal utilitzat
            } else if (GoogleCloudMessaging. MESSAGE_TYPE_MESSAGE.equals(messageType)) {                
            	String receivedMessage = (String)extras.get(PFCConstants.NOTIFICATIONDATA);
            	if(receivedMessage.equalsIgnoreCase(PFCConstants.ALARM_FIRED_TOKEN)){
            		AlarmScheduler.scheduleAlarm();	//Si es rep missatge d'alarma, es proprama el dispositiu per sonar
            	}
            	sendNotification("Message received: "+receivedMessage); //Notificacio amb la informacio rebuda
            	try {
					Thread.sleep(800);
				} catch (InterruptedException e) {					
					e.printStackTrace();
				}
                Log.i(PFCConstants.TAG, "Received: " + receivedMessage);
            }
        }
        // Alliberar el dispositiu per a que pugui entrar en repos de nou
        NotificationReceiver.completeWakefulIntent(intent);
    }

    //Contrueix la notificacio i la crea en el sistema.
    private void sendNotification(String msg) {
        mNotificationManager = (NotificationManager)
                this.getSystemService(Context.NOTIFICATION_SERVICE);

        PendingIntent contentIntent = PendingIntent.getActivity(this, 0,
                new Intent(this, MainActivity.class), 0);

        NotificationCompat.Builder mBuilder =
                new NotificationCompat.Builder(this)
        .setSmallIcon(R.drawable.ic_launcher)
        .setContentTitle("GCM Notification")
        .setStyle(new NotificationCompat.BigTextStyle()
        .bigText(msg))
        .setDefaults(Notification.DEFAULT_ALL)      
        .setContentText(msg);

        mBuilder.setContentIntent(contentIntent);
        mNotificationManager.notify(NOTIFICATION_ID, mBuilder.build());
    }
}
