package uoc.ei.pfc;

import java.util.ArrayList;
import java.util.HashMap;

public final class ParametersBuilder {
	
	//Construeix els perametres per a una peticio de consulta activa de l'estat de l'alarma
	public static ArrayList<String[]> testServer(){
		ArrayList<String[]> parameters = new ArrayList<String[]>();
		String[] testServer = {PFCConstants.TOKENMOBILE, PFCConstants.TESTNOTIFICATION};
		parameters.add(testServer);
		return parameters;		
	}
	
	//Construeix els perametres per a una peticio de registre del dispositiu al servidor
	public static ArrayList<String[]> registerOnServer(String id){
		ArrayList<String[]> parameters = new ArrayList<String[]>();
		String[] androidType = {PFCConstants.TOKENMOBILE, PFCConstants.REGISTER};
		String[] deviceId = {PFCConstants.TOKENDEVICEID, id};
		parameters.add(androidType);
		parameters.add(deviceId);
		return parameters;
	}
	
	//Construeix els perametres per a una peticio de parar alarma saltada
	public static ArrayList<String[]> stopAlarm(){
		ArrayList<String[]> parameters = new ArrayList<String[]>();
		String[] stopAlarm = {PFCConstants.TOKENMOBILE, PFCConstants.STOP_ALARM};
		parameters.add(stopAlarm);
		return parameters;
	}
	
	//Recupera els parametres a partir de la URL
	public static HashMap<String,String> handleCheckServer(String response){
		if(response != null && response.length()>0){ 
		String[] params = response.split("&");  
		    HashMap<String, String> map = new HashMap<String, String>();  
		    for (String param : params)  
		    {  
		        String name = param.split("=")[0];  
		        String value = param.split("=")[1];  
		        map.put(name, value);  
		    }  
		  return map;
		}
		else return null;
	}	
	
}
