package uoc.ei.pfc.alarm;

import java.util.GregorianCalendar;

import uoc.ei.pfc.MainActivity;
import uoc.ei.pfc.ParametersBuilder;
import uoc.ei.pfc.SendAsyncAction;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Intent;
import android.media.AudioManager;

public class AlarmScheduler {
	
	private static MainActivity main;
	
	public AlarmScheduler(MainActivity main){
		AlarmScheduler.main = main;
	}
	
	public static void scheduleAlarm(){
		
		Intent i = new Intent("uoc.ei.pfc.alarm.alarmactivity");
		
		//
		PendingIntent operation = PendingIntent.getActivity(main.getBaseContext(), 0, i, Intent.FLAG_ACTIVITY_NEW_TASK);
		
		// Obtenir instancia de l'alarma del sistema
		AlarmManager alarmManager = (AlarmManager) main.getBaseContext().getSystemService(MainActivity.ALARM_SERVICE);		
				
		main.setVolumeControlStream(AudioManager.STREAM_ALARM);			
	
		GregorianCalendar calendar = new GregorianCalendar();
		
		// Temps Unix actual mes 500ms. Fara sonar l'alarma del dispositiu casi instantaniament
		long alarm_time = calendar.getTimeInMillis()+500L;
		
	
		// Programacio de l'alarma al sistema.
        alarmManager.set(AlarmManager.RTC_WAKEUP  , alarm_time , operation);      
        // Consulta activa del Servidor per actualitzar el seu estat en el dispositiu
        SendAsyncAction.sendAction(ParametersBuilder.testServer());
	}

}
