package Debugger;

import java.awt.Label;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JTextArea;

public class RefreshUI extends Thread {

	private static JTextArea debug;		//TextArea de debug que es mostra a l'usuari
	public static Label wiflyStatus = new Label();
	public static Label wiflyLast = new Label();	
	public static Label androidClients = new Label();


	public RefreshUI(JTextArea textArea) {
		debug = textArea;
		
	}

	public synchronized static void println(String line) {//Synchronized per Threadsafe

		if (line != null) {	//Cada missatge nou crea un salt de linia.
			debug.append(line + "\n");
		}
		if (debug.getText().length() > 500) {	//Limita la mida del TextArea a 500
			debug.setText(debug.getText().substring(
					debug.getText().length() - 500, debug.getText().length()));
		}

	}
	
	public synchronized static void setWiflyStatus(String status){//Synchronized per Threadsafe
		wiflyStatus.setText(status+" On: "+getCurrentTime());
	}
	
	public synchronized static void setWiflyLast(String status){//Synchronized per Threadsafe
		wiflyLast.setText(status+" On: "+getCurrentTime());
	}
	
	private static String getCurrentTime(){//Obtenir l'hora actual per afegir-la a les etiquetes d'estat
		Date date = new Date();
		SimpleDateFormat dateFormat = new SimpleDateFormat("HH:mm:ss - dd/MM/yyyy"); 
		return dateFormat.format(date);
	}
}
