package Main;
import java.awt.Label;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.net.InetSocketAddress;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.text.DefaultCaret;

import ActionListeners.StartServersActionListener;
import ActionListeners.StopAlarmActionListener;
import Constants.PFCConstants;
import Debugger.RefreshUI;
import Notification.GCMData;
import Notification.Persistance;

import com.sun.net.httpserver.HttpServer;



public class Main {

	public static void main(String[] args) {   
		
	
		
		 JFrame AFrame = new JFrame("PFC Sistemes Encastats");
	   
		 Label wiflyStatusLabel = new Label(PFCConstants.WIFLY_STATUS_LABEL); //Etiqueta estat
		 wiflyStatusLabel.setBounds(57, 70, 150, 14);		
		 RefreshUI.wiflyStatus.setBounds(225, 70, 300, 14);
		 
		 Label wiflyLastLabel = new Label(PFCConstants.WIFLY_LAST_LABEL);	//Etiqueta ultim estat
		 wiflyLastLabel.setBounds(57, 95, 150, 14);
		 RefreshUI.wiflyLast.setBounds(225, 95, 300, 14);
		 
		 Label AndroidClientsLabel = new Label(PFCConstants.ANDROID_CLIENTS_LABEL);	//N clients Android
		 AndroidClientsLabel.setBounds(57, 120, 150, 14);
		 RefreshUI.androidClients.setBounds(225, 120, 300, 14);
		 
		 JButton startServer = new JButton(PFCConstants.START_SERVERS);	//Boto iniciar servidors
		 startServer.setBounds(612, 90, 110, 23);
		 startServer.addActionListener(new StartServersActionListener(startServer));
		 
		 JButton stopAlarm = new JButton(PFCConstants.STOP_ALARM_LABEL);	//Boto parar alarma saltada
		 stopAlarm.setBounds(741, 90, 110, 23);
		 stopAlarm.addActionListener(new StopAlarmActionListener());
		 
		

	     JTextArea textArea = new JTextArea(10, 50);
	     JScrollPane scrollPane = new JScrollPane(textArea); 
	     textArea.setEditable(false);
	     DefaultCaret caret = (DefaultCaret) textArea.getCaret();
	     caret.setUpdatePolicy(DefaultCaret.ALWAYS_UPDATE);
	    
	     //Valors per defecte al inicar la aplicacio
	     RefreshUI.wiflyStatus.setText(PFCConstants.DISCONNECTED);
	     RefreshUI.wiflyLast.setText("---");
	     RefreshUI.androidClients.setText("---");
	     
	    
	     //Afegir els elements a la finestra
	     AFrame.add(RefreshUI.wiflyStatus);
	     AFrame.add(RefreshUI.wiflyLast);
	     AFrame.add(RefreshUI.androidClients);
	     AFrame.add(wiflyStatusLabel);
	     AFrame.add(wiflyLastLabel);
	     AFrame.add(AndroidClientsLabel);
	     AFrame.add(startServer);
	     AFrame.add(stopAlarm);
	     
	      scrollPane.setBounds(120, 182, 732, 264);
	      AFrame.add(scrollPane);

	      //Tancar aplicacio al fer click a la creu 
	      FolderSelect panel = new FolderSelect();
	       AFrame.addWindowListener(
	         new WindowAdapter() {
	           public void windowClosing(WindowEvent e) {
	             System.exit(0);
	             }
	           }
	         );
	       
	       panel.setBounds(300, 250, 200, 200);
	       AFrame.add(panel);	      
	      
	      
	       
	       //No es pot modificar la mida
	       AFrame.setResizable(false);
	       AFrame.setVisible(true);	 
	       
	       //Actualitzacio de debug
	       RefreshUI debug = new RefreshUI(textArea);
	    
	      AFrame.setSize(970, 525);
	      
	      //Obtenir la llista de clients del fitxer de persistencia en cas que existeixi
	      GCMData androidDecives = null;		   
			try {
				androidDecives = Persistance.readGCMData();				
			} catch (Exception e1) {				
				e1.printStackTrace();
			}		     
			if(androidDecives != null){
				RefreshUI.androidClients.setText(String.valueOf(androidDecives.getDevicesToNotify().size()));				
			}

	}

}
