package Notification;
import java.util.List;

import Constants.PFCConstants;
import Debugger.RefreshUI;

import com.google.android.gcm.server.Message;
import com.google.android.gcm.server.MulticastResult;
import com.google.android.gcm.server.Result;
import com.google.android.gcm.server.Sender;


public class NotificationSender {	
		
	
	public static void sendNotification(String message) {
		final int retries = 3;
		Sender sender = new Sender(PFCConstants.apiKey);	//Key proporcionada per Google al registar-se per fer servir la API de notificacions.
		Message msg = new Message.Builder().addData(
				PFCConstants.notificationData, message).build();

		try {	//Enviament a tots els dispositius de la notificacio
			MulticastResult multicastResult = sender.send(msg, Persistance.readGCMData().getDevicesToNotify(), retries);

			if (multicastResult != null && multicastResult.getResults() != null) { //Comprova els resultats de l'enviament
				List<Result> results = multicastResult.getResults();
				for (Result result : results) {
					if (result.getErrorCodeName() != null	
							&& !(result.getErrorCodeName().isEmpty())) {RefreshUI.println("GCM Notification is sent successfully "+ result.getCanonicalRegistrationId()+ "  " + result.getMessageId());
					} else {
						//Si falla no notificacio es pot mostrar un missatge
					}
				}
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
