package Notification;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import Constants.PFCConstants;
import Debugger.RefreshUI;

public class Persistance {

	public void saveGCMData(GCMData data) throws Exception {	//Guarda a disc l'objecte GCMData
		
			FileOutputStream fout = new FileOutputStream(PFCConstants.persistancePath);
			ObjectOutputStream oos = new ObjectOutputStream(fout);
			oos.writeObject(data);
			oos.close();
			RefreshUI.androidClients.setText(String.valueOf(data.getDevicesToNotify().size()));
			RefreshUI.println("Object saved at "+PFCConstants.persistancePath);	
	}
	
	public static GCMData readGCMData() throws Exception {	//Llegeix el fitxer de persistencia, si no el troba marca --- al nombre de clients android
		GCMData data;
		try{
			checkFileCreation();			
			FileInputStream fin = new FileInputStream(PFCConstants.persistancePath);
			ObjectInputStream ois = new ObjectInputStream(fin);
			data = (GCMData) ois.readObject();
			ois.close();
			if(data != null){	//Si troba el fitxer recupera l'objecte i llegeix el nombre de clients Android
				RefreshUI.androidClients.setText(String.valueOf(data.getDevicesToNotify().size()));
			}
		}catch(Exception e){
			RefreshUI.androidClients.setText("---");
			return null;
		}
			return data;		
	}
	
	private static void checkFileCreation() throws Exception{	//Comprova l'existencia previa del fitxer	
		File f = new File(PFCConstants.persistancePath);
		if (!(f.exists()) || f.isDirectory()) {
			RefreshUI.println("File "+PFCConstants.persistancePath+" not found, it will be created.");
			f.createNewFile();	
		}
		else{
			RefreshUI.println("File "+PFCConstants.persistancePath+" found.");
		}
	}

}
